public class StringComparison{
	public static void main(String[] args) {
		
		// These two have the same value
		System.out.println(new String("test").equals("test"));

		// ... but they are not the same object
		System.out.println(new String("test") == "test");

		// ... neither are these
		System.out.println(new String("test") == new String("test"));

		// ... but these are because literals are interned by 
		// the compiler and thus refer to the same object
		System.out.println("test" == "test");

		// concatenation of string literals happens at compile time resulting in same
		// objects
		System.out.println("test" == "te" + "st");

		// but .substring() is invoked at runtime, generating distinct objects
		System.out.println("test" == "!test".substring(1));

		String salaryLevel = "A";
		System.out.println(salaryLevel.equals("A") || salaryLevel.equals("B"));
		System.out.println(salaryLevel == "A" || salaryLevel == "B");
	}
	
}