import java.io.*;
import java.util.Scanner;

public class EITSearchLabSampleSolution{
	public static void main(String[] args) throws IOException{
		
		final String EIT_FILE = "EIT.csv";	
		String [] EIT_records = readFile(EIT_FILE);

		String message = "Please enter the first name of a 2014 or 2015 EIT: ";
		String name = askForString(message);
		message = "Please enter the year of that EIT: ";
		String year = askForString(message);

		String result = checkEITYear(EIT_records, name, year);

		System.out.println(result);

		printResult(result);
	}

	static String [] readFile (String filename)	throws IOException {
		File file = new File(filename);

		Scanner scanner = new Scanner(file);

		String record = "";

		// this will return exactly one line, since there are no
		// line breaks in the csv file
		while(scanner.hasNextLine()){ 
			record = record + scanner.nextLine();
		}

		scanner.close();

		String[] content = record.split(";");

		return content;
	}

	static String checkEITYear(String [] EIT_records, String name, String year) {
		String[] eit;
		String message ="";

		for(int i = 0; i < EIT_records.length; i++){
			eit = EIT_records[i].split(",");
			if(eit[0].equals(name)){
				if(eit[1].equals(year)){
					message = "Name and Year match";
					return message;
				}else{
					message = "Year does not match";
					return message;
				}
			}
		}
		message ="No match";
		return message;
	}

	static void printResult (String result) throws IOException {
		File outFile = new File("outFile.txt");
		PrintWriter pw = new PrintWriter(outFile);

		pw.write(result);
		pw.close();
	}

	static String askForString (String message) throws IOException{
		
		System.out.print(message);
		BufferedReader keyboard = new BufferedReader(new InputStreamReader(System.in));
		String response = keyboard.readLine();

		return response;
	}
}