public class DebitAccount extends Account{
	private double debitLimit;
	private double debitInterestRate;

	public DebitAccount(String accountHoldersName, 
		String accountNumber, double amount, double
		interestRate, double debitInterestRate,
		double debitLimit){
		super(accountHoldersName, accountNumber, 
        amount, interestRate);
        this.debitLimit = debitLimit;
        this.debitInterestRate = debitInterestRate;
	}

	public double getDebitLimit(){
		return this.debitLimit;
	}

	public void setDebitLimit(double debitLimit){
		this.debitLimit = debitLimit;
	}	

	public double getDebitInterestRate(){
		return this.debitInterestRate;
	}

	public void setDebitInterestRate(double 
		debitInterestRate){
		this.debitInterestRate = debitInterestRate;
	}

	public String toString(){
		String content = super.toString() 
		+ "\nDebit Limit: "+ debitLimit 
		+ "\nDebit Interest: "+ debitInterestRate;
		return content;
	}

	public void applyInterestRate(){
		if(amount < 0){
			amount = amount + (debitInterestRate * amount);
			updateHistory("Debit interest rate applied. New amount is "+amount);
		}else{
			amount = interestRate * amount + amount;
			updateHistory("Interest rate applied. New amount is "+amount);
		}
	}

	public void processTransfer(double amount){
		if(debitLimit <= this.amount + amount){
			this.amount = this.amount + amount;
            updateHistory("Amount: "+amount+" was processed on your"
                +" account. New balance is: "+this.amount);
		}else{
			updateHistory("Transaction could not be completed, because you would reach your debit limit.");
		}
	}

	
}