package mest.account;

public abstract class Account implements Comparable<Account>{ 

    private String accountHoldersName;
    private String accountNumber;
    private String history;
    protected double amount;
    protected double interestRate;
    private static final long BANK_ID = 80056322;
    private static int numberOfAccounts = 0;

    public Account(String accountHoldersName, 
        String accountNumber, 
        double amount,
        double interestRate){
        this.accountHoldersName = accountHoldersName;
        this.accountNumber = accountNumber;
        this.amount = amount;
        this.interestRate = interestRate;
        history ="";
        numberOfAccounts++; 
    }

    public Account(String accountHoldersName, 
        String accountNumber, double interestRate){
        this.accountNumber = accountNumber;
        this.accountHoldersName = accountHoldersName;
        this.interestRate = interestRate;
        amount = 0.0;
        history = "";
        numberOfAccounts++;
    }

    // this may be proctected, but not private
    public abstract void processTransfer(double amount);
    /*{
        if(!isAmountPositive() && amount < 0){
            updateHistory("Transaction could not be completed.");
        }else{
            this.amount = this.amount + amount;
            updateHistory("Amount: "+amount+" was processed on your"
                +" account. New balance is: "+this.amount);
        }    	
    }*/

    protected void updateHistory(String entry){
        history = history + "\n" + entry;
    }

    protected boolean isAmountPositive(){
    	return amount >= 0;
    }

    public String toString(){
        return super.toString() + "\nBank Id: " + BANK_ID 
        + "\nName: "+ accountHoldersName +
        "\nAccount Number: "+ accountNumber + "\nAmount: " + amount
        + "\nInterest Rate: " + interestRate;
    }

    public String getAccountHoldersName(){
        return accountHoldersName;
    }

    public static long getBankId(){
        return BANK_ID;
    }

    public String getAccountNumber(){
        return accountNumber;
    }

    public double getAmount(){
        return amount;
    }

    public String getHistory(){
        return history;
    }

    public static int getNumberOfAccounts(){
        return numberOfAccounts;
    }

    public double getInterestRate() {
        return this.interestRate;
    }

    public void setInterestRate(double interestRate) {
        this.interestRate = interestRate;
    }

    @Override
    public int compareTo(Account other){
        if (amount < other.getAmount()){
            return -1;
        }
        if (amount > other.getAmount()){
            return 1;
        }
        return 0;
    }

    /*@Override
    public int compareTo(Object otherObject){
        Account other = (Account)otherObject;
        if (amount < other.getAmount()){
            return -1;
        }
        if (amount > other.getAmount()){
            return 1;
        }
        return 0;
    }*/

}