package mest.account;
public class DebitAccount extends Account{
	private double interestRateDebit;
	private double debitLimit;

	public DebitAccount(String accountHoldersName, 
        String accountNumber, double amount, double interestRate, 
        double interestRateDebit, double debitLimit){
		super(accountHoldersName, accountNumber, amount, interestRate);
		this.interestRateDebit = interestRateDebit;
		this.debitLimit = debitLimit;
	}

	public double getDebitLimit() {
	    return this.debitLimit;
	}

	public void setDebitLimit(double debitLimit) {
	    this.debitLimit = debitLimit;
	}

	public double getInterestRateDebit() {
	    return this.interestRateDebit;
	}

	public void setInterestRateDebit(double interestRateDebit) {
	    this.interestRateDebit = interestRateDebit;
	}

	public void processTransfer(double amount){
		if(this.amount + amount < debitLimit){
            updateHistory("Transaction could not be completed: "+amount);
        }else{
            this.amount = this.amount + amount;
            updateHistory("Amount: "+amount+" was processed on your"
                +" account. New balance is: "+this.amount);
        }
	}

	public String toString(){
		return super.toString() 
		 + "\nInterest Rate Debit: " + interestRateDebit
		 + "\nDebit Limit: " + debitLimit;
	}

	public void applyInterestRate(){
		double interest = 0.0;
		if(isAmountPositive()){
			interest = amount * interestRate;
			amount += interest;
			updateHistory("Interest: "+(interest)+" was added to your"
                +" account. New balance is: "+this.amount);
		}else{
			interest  = amount * interestRateDebit;
			amount += interest;
			updateHistory("Interest: "+(interest)+" was subtracted from your"
                +" account. New balance is: "+this.amount);
		}
	}

}