package mest.account;
import java.util.*;
public class FixedDepositAccount extends Account{

	private GregorianCalendar endDate;

	public FixedDepositAccount(String accountHoldersName, 
        String accountNumber, double amount, 
        double interestRate, GregorianCalendar endDate){
		super(accountHoldersName, accountNumber, amount, interestRate);
		this.endDate = endDate;
	}

	public String toString(){
		return super.toString() 
		 + "\nEnd Date: " + createDateString(endDate);
	}

	private String createDateString(GregorianCalendar date){
		return date.get(Calendar.DAY_OF_MONTH) +"/"+
		(date.get(Calendar.MONTH) + 1) +"/"+
		date.get(Calendar.YEAR);
	}

	public void applyInterestRate(){		
		double interest = amount * interestRate;
		amount += interest;
		updateHistory("Interest: "+(interest)+" was added to your"
        +" account. New balance is: "+this.amount);		
	}

	public void processTransfer(double amount){
		GregorianCalendar now = new GregorianCalendar();
		if(amount > 0 || (now.compareTo(endDate)>0 && 
			this.amount + amount >= 0)){
			this.amount = this.amount + amount;
            updateHistory("Amount: "+amount+" was processed on your"
                +" account. New balance is: "+this.amount);
		}else{
			 updateHistory("Transaction could not be completed:" + amount +
			 	" on "+createDateString(now));
		}
	}

	public GregorianCalendar getEndDate() {
	    return this.endDate;
	}

	public void setEndDate(GregorianCalendar endDate) {
	    this.endDate = endDate;
	}
}
