package mest.bank;
import mest.account.*;
import java.io.*;
import java.util.Arrays;
import java.util.GregorianCalendar;

public class Bank{
	private Account[] accounts;
	private int currentAccount = 0;
	private int numberOfAccounts =0;


	public Bank(int noAccounts){
		// accounts are initialized with null
		accounts = new Account[noAccounts];
	}

	public boolean insertAccount(Account account){
		if(currentAccount < accounts.length){
			accounts[currentAccount] = account;
			currentAccount ++;
			numberOfAccounts ++;
			return true;
		}else{
			return false;
		}		
	}

	public void getAccount(String accountNumber){
		for(int i = 0; i < currentAccount; i++){
			if(accounts[i].getAccountNumber().equals(accountNumber)){
				System.out.println(accounts[i]);
				return;
			}
		}
		System.out.println("Account not found");
	}

	public boolean deleteAccount(String accountNumber){
		for(int i = 0; i < currentAccount; i++){
			if(accounts[i].getAccountNumber().equals(accountNumber)){
				for(int j = i+1; j < currentAccount; j++){
					accounts[i] = accounts[j];
					i++;
				}
				accounts[currentAccount -1] = null;
				currentAccount--;
				return true;
			}
		}
		return false;		
	}

	public int getNumberOfAccounts(){
		return numberOfAccounts;
	}

	public void sortAccounts(){
		Arrays.sort(accounts, 0, currentAccount);
	}

	public void displayAllAccounts(){
		for(int i = 0; i < currentAccount; i++){
			System.out.println(accounts[i].getAccountNumber() + " : "
			+ accounts[i].getAmount() + " GHS");
		}
	}

	public void menu() throws IOException{
		int i = 0;
		int j = 0;
		while(i != 4){
			i = askForInt("What do you want to do? (1) Add Account (2) Display Account (3) Delete Account (4) Exit Program:  ");
			if(i == 1){
				j = askForInt("Which kind of account? (1) Debit Account (2) Fixed Deposit Account: ");
				String accountName = askForString("Enter Account Holder's Name: ");
				String accountNumber = askForString("Enter Account Number: ");
				double amount = askForDouble("Enter Inital Amount: ");
				double interestRate = askForDouble("Enter Interest Rate: ");
				if(j == 1){
					double debitLimit = askForDouble("Enter Debit Limit: ");
					double interestRateDebit = askForDouble("Enter Interest Rate for Debit: ");
					DebitAccount account  = new DebitAccount(accountName, accountNumber, 
						amount, interestRate, debitLimit, interestRateDebit);
					if(!insertAccount(account)){
						System.out.println("Could not add account");
					}
				}else if(j == 2){
					System.out.println("When can the customer access the money?");
					int year = askForInt("Enter the year: ");
					int month = askForInt("Enter the month (1-12): ");
					int day = askForInt("Enter the day: ");
					GregorianCalendar endDate = new GregorianCalendar(year,month-1,day);
					FixedDepositAccount account = new FixedDepositAccount(accountName,
						accountNumber, amount, interestRate, endDate);
					if(!insertAccount(account)){
						System.out.println("Could not add account");
					}
				}else{
					System.out.println("Invalid input");
				}
			}
			else if(i == 2){
				String accountNumber = askForString("Enter Account Number: ");
				getAccount(accountNumber);
			}
			else if(i == 3){
				String accountNumber = askForString("Enter Account Number: ");
				if(!deleteAccount(accountNumber)){
					System.out.print("Could not find that account");
				}
			}
			else if(i == 4){
				displayAllAccounts();
			}
			else{
				System.out.println("Invalid input!");
			}
		}
	}

	private String askForString(String message) throws IOException{
		System.out.println();
		System.out.print(message);

		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
		
		return input.readLine();
	}


	private int askForInt(String message) throws IOException{
		System.out.println();
		System.out.print(message);

		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
		
		return Integer.parseInt(input.readLine());
	}

	private double askForDouble(String message) throws IOException{
		System.out.println();
		System.out.print(message);

		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
		
		return Double.parseDouble(input.readLine());
	}
}