package mest.account;
public abstract class Account implements Comparable{

    private String accountHoldersName;
    private String accountNumber;
    protected double amount;
    private String history;
    protected double interestRate;
    private static final long BANK_ID = 80056322;
    private static int numberOfAccounts = 0;

    public Account(String accountHoldersName, 
        String accountNumber, 
        double amount, double interestRate){
        this.accountHoldersName = accountHoldersName;
        this.accountNumber = accountNumber;
        this.amount = amount;
        this.interestRate = interestRate;
        history ="";
        numberOfAccounts++; 
    }


     public Account(String accountHoldersName, 
        String accountNumber){
        this.accountNumber = accountNumber;
        this.accountHoldersName = accountHoldersName;
        amount = 0.0;
        history = "";
        numberOfAccounts++;
    }

    public int compareTo(Object anotherObject){
        // transform Object reference into Account reference (typecasting)
        Account other = (Account)anotherObject;
        if(this.amount > other.getAmount()){
            return 1;
        } else if(this.amount == other.getAmount()){
            return 0;
        }else{
            return -1;
        }

    }

    public abstract void processTransfer(double amount);

    protected void updateHistory(String entry){
        history = history + "\n" + entry;
    }

    public boolean isAmountPositive(){
    	return amount >= 0;
    }

    public String toString(){
        
        return "Bank Id: " + BANK_ID 
        + "\nName: "+ accountHoldersName +
        "\nAccount Number: "+ accountNumber 
        + "\nAmount: " + amount
        + "\nInterest Rate: "+interestRate;
    }


    public String getAccountHoldersName(){
        return accountHoldersName;
    }

    public static long getBankId(){
        return BANK_ID;
    }

    public String getAccountNumber(){
        return accountNumber;
    }

    public double getAmount(){
        return amount;
    }

    public String getHistory(){
        return history;
    }

    public static int getNumberOfAccounts(){
         return numberOfAccounts;
    }

    public double getInterestRate(){
        return interestRate;
    }

    public void setInterestRate(double interestRate){
        this.interestRate = interestRate;
    }
 
}