package mest.account;
import java.util.*;

public class FixedDepositAccount extends Account{

	private GregorianCalendar endDate;

	public FixedDepositAccount(String 
		accountHoldersName, String accountNumber, 
		double amount, double interestRate, 
		GregorianCalendar endDate){
		super(accountHoldersName, accountNumber, 
        amount, interestRate);
        this.endDate = endDate;        
	}


	public GregorianCalendar getEndDate() {
	    return this.endDate;
	}

	public void setEndDate(GregorianCalendar 
		endDate) {
	    this.endDate = endDate;

	}

	public String toString(){
		String content = super.toString() +
		 "\nEnd Date: " + printDate();

		return content;
	}

	private String printDate(){
		return endDate.get(Calendar.YEAR) +
		 "/"+ (endDate.get(Calendar.MONTH)+1) + "/" 
		 + endDate.get(Calendar.DAY_OF_MONTH);
	}

	public void processTransfer(double amount){
		GregorianCalendar now = new GregorianCalendar();
		// is the transferred amount positive?
		if(amount >= 0){
			this.amount = this.amount + amount;
            updateHistory("Amount: "+amount+" was processed on your"
                +" account. New balance is: "+this.amount);
		}
		// has the end date been reached?
		else if(endDate.compareTo(now) == 1){
			updateHistory("Transaction could not be completed, because the end date has not passed yet.");
		// will you get a negative amount after process?
		}else if((this.amount + amount) < 0){
			updateHistory("Transaction could not be completed, because you would reach a negative amount.");
		// legal amount (cash withdrawal, end date passed, no negative amount afterwards)	
		}else{
			this.amount = this.amount + amount;
            updateHistory("Amount: "+amount+" was processed on your"
                +" account. New balance is: "+this.amount);
		}		
	}

	// Alternative for processTransfer()
	/*public void processTransfer(double amount){
		GregorianCalendar now = new GregorianCalendar();
		if(amount > 0 || (now.compareTo(endDate)>0 && 
			this.amount + amount >= 0)){
			this.amount = this.amount + amount;
            updateHistory("Amount: "+amount+" was processed on your"
                +" account. New balance is: "+this.amount);
		}else{
			 updateHistory("Transaction could not be completed:" + amount +
			 	" on "+createDateString(now));
		}
	}*/

	public void applyInterestRate(){
		amount = interestRate * amount + amount;
		updateHistory("Interest rate applied. New amount is "+amount);
	}

}