public class Dog{

	private String name;
	private String race;
	private boolean hungry;
	private boolean happy;
	private boolean tired;
	private boolean alive;
	private int roundsPlayed = 0;
	private static int numberOfDogs = 0;

	public Dog(String name, String race){
		this.name = name;
		this.race = race;
		hungry = false;
		happy = true;
		tired = false;
		alive = true;
		numberOfDogs ++;
	}

	public void bark(){
		if(alive){
			System.out.println(name+": Wooof");
		}
	}

	public void sleep(){
		if(alive){
			System.out.println(name+": ZZzzzz");
			tired = false;
		}
	}

	public void eat(){
		if(alive){
			System.out.println(name+": Mmpfmmppf");
			hungry = false;
		}
	}

	public void play(){
		if(alive && !tired && !hungry){
			System.out.println(name+": Wooof Wooof");
			happy = true;
			hungry = true;
			if(roundsPlayed == 1){
				tired = true;
				roundsPlayed = 0;
			}
			roundsPlayed++;
		}
	}

	public void fight(Dog rival){
		if(alive){
			happy = false;
			System.out.println(name+": Grrrrr");
			if (Math.random() < 0.5){
				die();
			}else{
				rival.die();
			}
		}
	}

	public void die(){
		alive = false;
		happy = false;
		hungry = false;
		tired = false;
		numberOfDogs --;
	}

	public String toString(){
		String dogAsString = "Dog: "+name+"\nRace: "+race;
		if(!alive){
			dogAsString += "\nDeceased.";
		}else{
			if (happy){
				dogAsString += "\nhappy, ";
			}else{
				dogAsString += "\nunhappy, ";
			}
			if (hungry){
				dogAsString += "hungry, ";
			}else{
				dogAsString += "full, ";
			}
			if (tired){
				dogAsString += "tired.\n";
			}else{
				dogAsString += "well-rested.\n";
			}

		}
		return dogAsString;
	}

	public static int getNumberOfDogs(){
		return numberOfDogs;
	}


}