import java.util.*;

public class GenericWildcard {
	public static void main(String[] args) {
		
		List<Person> newYorkers = new ArrayList<Person>();
		List<Doctor> surgeons = new ArrayList<Doctor>();
		List<Athlete> ballers = new ArrayList<Athlete>();

		Person jayz = new Person();
		Doctor freud = new Doctor();
		Athlete timHoward = new Athlete();

		newYorkers.add(jayz);
		newYorkers.add(freud);		//pretend he's NY
		newYorkers.add(timHoward);	

		//print the list
		processElements(newYorkers);
		System.out.println();
		//print the list now with inheritance checking
		processExtendedElements(newYorkers);
		//insertElements(newYorkers);				//add new elements to the list by passing to the method
		//processElements(newYorkers);			//print the list to see the new elements
	}	

	//"Unknown" Wildcard
	//means that this list could be any type but can be 
	//treated as Objects
	public static void processElements (List<?> elements) {
		for(Object obj : elements) {
			System.out.println(obj);
		}
	}

	//"Extends" Wildcard Boundary
	//means list of objects being passed are either instaces of Person or subclasses
	//which allows safe reads of instances and cast them to parent class ((Person) Doctor)
	public static void processExtendedElements (List<? extends Person> elements) {
		for(Person per : elements) {
			System.out.println(per);
		}
	}

	//"Super" Wildcard Boundary
	//means that list is typed to Person or superclass of Person...
	//which allows safe insertion of any classes of Person or subclasses of Person
	//(e.g., "Doctor" and "Athlete" inherit from Person)
	public static void insertElements (List<? super Person> people) {
		people.add(new Person());
		people.add(new Doctor());
		people.add(new Athlete());
	}
}

class Person{
	public String toString(){
		return super.toString() + "(a person)"; 
	}
}

class Doctor extends Person{
	public String toString(){
		return super.toString() + "(a doctor)"; 
	}
}

class Athlete extends Person{
	public String toString(){
		return super.toString()+ "(an athlete)"; 
	}
}