import java.io.*;
public class BinarySearch{

	public static void main(String[] args) throws Exception{

		// generate random array
		int [] array = 	generateField(10);

		// display array
		for(int i = 0; i < array.length; i++){
			System.out.print(" "+array[i]);
		}	
		System.out.println();
		
		int value = askForInt("Which value are you looking for.");

		while(value != -1){
			
			//int position = binarySearch(value, array);
			int position = interpolationSearch(value, array);
		
			if(position == -1){
				System.out.println("It is not contained in the array.");
			} else {
				System.out.println("The value is on position "+position+ " (index "+(position-1)+").");
			}

			value = askForInt("Which value are you looking for? ");
		}
	}

	public static int binarySearch(int value, int[] array){
		int left = 0;
		int right = array.length-1;
		while(left <= right){
			int middle = (left+right)/2;
			if(value==array[middle]){
				return middle+1;
			}else if (value>array[middle]){
				left = middle+1;
			}else{
				right=middle-1;
			}
		}
		return-1;
	}

	public static int interpolationSearch(int value, int[] array){
		int left = 0;
		int right = array.length-1;
		while(left <= right){
			int middle = left + (right - left) * ((value - array[left])/(array[right]-array[left]));
			if(value==array[middle]){
				return middle+1;
			}else if (value>array[middle]){
				left = middle+1;
			}else{
				right=middle-1;
			}
		}
		return-1;
	}

	// generates a sorted array with positive values of the length number
	public static int[] generateField(int number) {
		int[] field = new int[number];

		//first entry 
		field[0] = (int)((Math.random()*20)-10);

		//following entries are based on previous ones
		for(int i=1; i<number; i++){
			field[i] = field[i-1] + ((int)((Math.random()*10)));
		}
		
		return field;
	}

	static int askForInt(String message) throws IOException{
		System.out.println();
		System.out.print(message);

		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
		
		return Integer.parseInt(input.readLine());
	}
}