public class HeapSort{
	public static void main(String[] args) {
		int [] field = {1,5,3,1,8,7,2,4};
		//int [] field = {11,7,9,8,5,4};
		Helper.printArray(field);

		heapSort(field);

		Helper.printArray(field);
	}

	public static void heapSort(int[] list){

		// make the list a heap
		heapify(list);

		int i = list.length-1;
		/*
		* move first element to end of unsorted area and decrease
		* unsorted area by 1 (i.e. create a sorted area)
		*/
		while(i > 0){
			System.out.println("Move element "+list[0]+ " to the end of the list.");
			// swap the root of the heap with the last element of the heap
			swap(list, 0, i);
			// increase sorted area/ decrease unsorted (i.e. considered) area
			i --;
			// restore max-heap order
			siftDown(list, 0, i);
			System.out.print("Restore max-heap order: ");
			Helper.printArray(list);
		} 
	}

	/* 
	 * First phase of heap sort. The binary search tree has to be a heap.
	 * This means: list[i] > list[2*i] && feld[i] > feld[2*i+1]. 
	*/
	 private static void heapify(int[] list){
	 	System.out.println("Starting Heapify..");

	    /*
	    * start is assigned to index in list of the last parent node
	    * (i.e. node having at least one child)
	    */
	 	int start = (list.length - 2 ) / 2;

	 	// iterate through parent nodes (start..0) moving up the tree
	 	while(start >= 0){
	    	// sift down node at index start to proper place such that
	    	// all nodes below start index are in heap order
	 		siftDown(list, start, list.length-1);

	 		start--;
	 	} 

	 	System.out.print("Done with Heapify: ");
	 	Helper.printArray(list);
	 	System.out.println();

	 }

		/*
		* sift down elements from root start to end
		* starting from root: swap root with max(root, child left, child right)
		* do this until the component copied at last only has children less or equal itself
		*/
	 private static void siftDown(int[] list, int root, int end){

	 	System.out.println("Start sorting subtree with root "+list[root] +".");

		// root element has to have at least one child
	 	while(root*2+1 <= end ){

			int child = root*2+1; // left child
			int swap = root; // element to swap with

			// is root smaller than left child? 
			if(list[swap] < list[child]){
				swap = child;	
			}

			// if right child exists, is it bigger than current swap?
			if(child+1 <= end && list[swap] < list[child+1]){
				swap = child + 1;
			}
			
			// perform swap if left or right element are greater than parent
			if(swap != root){
				System.out.println("Swapping "+list[root]+ " and "+list[swap]);
				swap(list, root, swap);
				
				// new root element is 
				root = swap;				
			}else{
				return;
			}
		}
	}
	
	// swaps elements at indicies a and b in list 
	public static void swap(int[] list, int a, int b){
		int temp = list[b];
		list[b] = list[a];
		list[a] = temp;
	}
}