public class MergeSort{
	public static void main(String[] args) {
		int [] field = {3,7,8,5,2,1,9,5,4};
		Helper.printArray(field);

		field = mergeSort(field);

		Helper.printArray(field);	
	}

	static int [] mergeSort(int[] list){

		// list of length 1 is sorted
		if(list.length <= 1){
			System.out.println("Sublist of length 1. No need to sort this.");
			return list;
		}

		// divide into left and right part
		int[] left = sublist(list, 0, (list.length-1)/2);
		int[] right = sublist(list, ((list.length-1)/2)+1, list.length-1);

		System.out.println("Divide list of length "+ list.length +" into left list from 0 "+
			"to "+ (list.length-1)/2 + " and right list from "+((list.length-1)/2+1)+" to "+(list.length-1));

		// merge left list
		left = mergeSort(left);
    	// merge right list
    	right = mergeSort(right);

    	return merge(left, right);

	}

	// merge and sort two sorted lists
	private static int[] merge(int[] left, int[] right){

		int [] merged = new int[left.length+right.length];
		
		int leftIndex = 0;
		int rightIndex = 0;
		int mergedIndex = 0;
		
		System.out.println("Merging Lists");
		Helper.printArray(left);
		Helper.printArray(right);
		
		// while at least one list has not been fully iterated
		while(leftIndex < left.length || rightIndex < right.length){
			// case one: both lists not finished yet
			if(leftIndex < left.length && rightIndex < right.length){
				// add element of left list to merged list
				if(left[leftIndex] <= right[rightIndex]){
					merged[mergedIndex]= left[leftIndex];
					leftIndex++;
				// add element of right list to merged list
				}else{
					merged[mergedIndex]= right[rightIndex];
					rightIndex++;
				}
			// case two: only left list not finished yet
			}else if(leftIndex < left.length){
				// append one element of left list
				merged[mergedIndex]= left[leftIndex];
				leftIndex++;
			// case two: only right list not finished yet
			}else{
				// append one element of right list
				merged[mergedIndex]= right[rightIndex];
				rightIndex++;
			}
			mergedIndex++;
		}
		Helper.printArray(merged);

		return merged;
	}

	// creates sublist of input list, range: from - to indices
	private static int[] sublist(int[] list, int from, int to){
		//System.out.println(from +" "+ to);
		int [] sublist = new int[to-from+1];
		for (int i = 0; i < sublist.length; i++){
			sublist[i] = list[i+from];
		}
		return sublist;
	}
}