public class QuickSort{
	public static void main(String[] args) {
		int [] field = {3,7,8,5,2,1,9,5,4};
		Helper.printArray(field);

		quickSort(field,0,field.length-1);

		Helper.printArray(field);
	}

	// optimized version using 
	static void quickSort(int[] list, int left, int right){
		if(left < right){

			// simple way to determine pivot element, simply the middle element
			int pivotIndex = left;//(left + right) / 2;

			System.out.print("Sorting List: ");
			printArrayPivot(list, left, right, pivotIndex);

			// move elements smaller than pivot element to left and elements greater to right
			int newPivotIndex = partition(list, left, right, pivotIndex);

			System.out.print("After Partitioning: ");
			printArrayPivot(list, left, right, newPivotIndex);
			
			// recursively sort list left of the pivot element
			quickSort(list, left, newPivotIndex - 1);

			// recursively sort list right of the pivot element
			quickSort(list, newPivotIndex + 1, right);

		}
	}

	/* this method moves all elements less than the pivot element to the left
	 * and all elements greater than the pivot element to the right
	 * it is optimized to save space
	 */
	static private int partition(int[] list, int left, int right, int pivotIndex){

		int storeIndex = left;
		int pivotValue = list[pivotIndex];

		// move pivot to the end
     	int temp = list[right];
     	list[right] = list[pivotIndex];
     	list[pivotIndex] = temp;

     	for(int i = left; i <= right-1; i++){
			if(list[i] <= pivotValue){

				// swap element at storeIndex with this element
				temp = list[i];
				list[i] = list[storeIndex];
				list[storeIndex] = temp;

				storeIndex++;
				//printArray(list);
			}
		} 

		// move pivot back
		temp = list[storeIndex];
		list[storeIndex] = list[right];
		list[right] = temp;

		return storeIndex;
	}


	static void printArrayPivot(int[] field, int left, int right, int pivotIndex){
		for(int i = left; i <= right; i++){
			if(i == pivotIndex) System.out.print("  ("+field[i]+")");
			else System.out.print("  "+field[i]);
		}
		System.out.println();
		System.out.println();
	}
}