import java.awt.*;
import javax.swing.*;


public class GUI { // BLACKBOX VERMWENDUNG
	private DrawFrame frame; 
	
	public void init(boolean [][] matrix) {	
		frame = new DrawFrame(matrix);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.show();
	}
	
	public void show(boolean [][] matrix){
		frame.show(matrix);
	}
}

class DrawFrame extends JFrame {
	DrawPanel panel;
	
	public DrawFrame(boolean [][] matrix){
		setTitle("Spiel des Lebens");
		setSize(4*matrix.length+100, 4*matrix[0].length+100);
		panel = new DrawPanel(matrix);
		Container contentPane = getContentPane();
		contentPane.add(panel);
	}
	
	public void show(boolean [][] matrix){
		panel.setMatrix(matrix);
		panel.repaint();
	}
}

class DrawPanel extends JPanel {
	boolean [][] panelMatrix;
	
	DrawPanel(boolean [][] panelMatrix){
		this.panelMatrix = panelMatrix;
	}
	void setMatrix(boolean [][] matrix){
		panelMatrix = matrix;
	}
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		for(int i=0; i<panelMatrix.length; i++){
			for(int j=0; j<panelMatrix[0].length; j++){
				g.setColor(panelMatrix[i][j]==true ? Color.BLACK : Color.white);
				g.fillRect(50+i*4,50+j*4, 3, 3);
			}
		}
	}
}
