public class Lifegame {

	public static void main(String[] args) throws InterruptedException {
		// create the graphic interface
		GUI gui = new GUI();	
		// create a random matrix in the beginning
		boolean matrix [][] = createRandomMatrix();		
		// initialize gui with random matrix
		gui.init(matrix);
		// wait for 3 seconds
		Thread.sleep(1000);	
		while (true){
			// calculate next step
			matrix = calculateNextStep(matrix);
			// display next step
			gui.show(matrix);
			Thread.sleep(20);
		}
	}
	
	public static boolean [][] createRandomMatrix(){
		boolean [][] matrix;
		int width = 200;
		int height = 200;
		matrix = new boolean[width][height];
		for(int i=0; i<width; i++){
			for(int j=0; j<height; j++){
				matrix[i][j] = (int)(Math.random()*100)<60 ? false : true; 
			}
		} 
		return matrix;
	}
	
	public static boolean [][] calculateNextStep(boolean [][] oldMatrix){
		int width = oldMatrix.length;
		int height = oldMatrix[0].length;
		boolean newMatrix [][] = new boolean[width][height];
		for(int i=0; i<width; i++){
			for(int j=0; j<height; j++){
				int number=countNeighbours(oldMatrix,i,j); 						
				newMatrix[i][j]=false;											
				if((oldMatrix[i][j]==true)&&((number==2)||(number==3)) ){		
					newMatrix[i][j]=true;
				}
				if(number==3){									
					newMatrix[i][j]=true;
				}
			}
		}
		return newMatrix;
	}
	
	public static int countNeighbours(boolean [][] matrix, int i, int j){
		int number = 0;
		
		int iMinus1 = i-1<0 ? matrix.length-1 : i-1;
		int jMinus1 = j-1<0 ? matrix[0].length-1 : j-1;
		int iPlus1 = i+1>matrix.length-1 ? 0 : i+1;
		int jPlus1 = j+1>matrix[0].length-1 ? 0 : j+1;
		
		if (matrix[iMinus1][jMinus1]) number++;
		if (matrix[iMinus1][j]) number++;
		if (matrix[iMinus1][jPlus1]) number++;
		
		if (matrix[i][jMinus1]) number++;
		if (matrix[i][jPlus1]) number++;
		
		if (matrix[iPlus1][jMinus1]) number++;
		if (matrix[iPlus1][j]) number++;
		if (matrix[iPlus1][jPlus1]) number++;
		
		return number;
	}	
	
}
