import org.junit.Test;
import static org.junit.Assert.*;

import mest.entity.*;
import mest.utility.*;

public class TestJUnit{

	@Test
	public void testDefaultTheme() {
		User falk = new User("Falk", "Benke", 
			"fbenke", "falk@meltwater.org", 
			"holiday", "Teaching Fellow at MEST");
		assertNotNull("No default theme in theme manager", 
			falk.getActiveTheme());
	}

	@Test
	public void testAddingTags(){
		User falk = new User("Falk", "Benke", "fbenke", 
			"falk@meltwater.org", "holiday", 
			"Teaching Fellow at MEST");

		falk.addTag("HPI");
		falk.addTag("Machine Learning");
		falk.addTag("Theoretical Computer Science");
		falk.addTag("Schuhplattler");

		assertTrue("Failure while adding tags",
			falk.getTagList().size() == 4);
	}

	@Test
	public void testRemovingTags(){
		User falk = new User("Falk", "Benke", "fbenke", 
			"falk@meltwater.org", "holiday", 
			"Teaching Fellow at MEST");

		falk.addTag("HPI");
		falk.addTag("Machine Learning");
		falk.addTag("Theoretical Computer Science");
		falk.addTag("Schuhplattler");

		assertFalse("Failure while removing tags",
			falk.getTagList().remove("IOS development"));
	}
}
