package mest.entity;

import mest.entity.ServiceManager;
import java.util.HashSet;

/**class for managing services supported by MESTly in a private set supportedServices (probably by an admin person)*/
public class ServiceManager{

	/**set of supported services*/
	private static HashSet<String> supportedServices = 	new HashSet<String>();	


    public static HashSet<String> getSupportedServices() {
	    return supportedServices;
	}

	/**
	Adds a service to the set of supported services.
	@param service to be added
	@return boolean describing if addding was successful
	*/
	public static boolean addSupportedService(String service){
		return supportedServices.add(service);
	}

	/**
	Removes a supported service from the set.
	@param service that is supposed to be added
	@return boolean describing if addding was successful
    */
	public static boolean removeSupportedService(String service){
		return supportedServices.remove(service);
	}
	
	/**
	Checks if given service is in list of supported services.
	@param service that is checked
	@return boolean describing if the service is supported
	*/
	public static boolean isSupportedService(String service){
		return supportedServices.contains(service);
	}
}