package mest.entity;

import java.net.URL;

/**class describing a theme*/
public class Theme{

    private static long numberOfThemeIDs = 0;
	protected long uid = 0;
	protected String title;
	protected URL url;

	/**
	This constructor assigns the passed values to the object and creates a new uid,
	that is unique among all theme objects by using numbers starting from 0..n.
	@param title of the theme
	@param url pointing to the css file for the theme
	*/
	public Theme(String title, URL url){
		this.title = title;
		this.url = url;
		uid = numberOfThemeIDs;
		numberOfThemeIDs++;
	}
	
	public String getTitle() {
	    return this.title;
	}

	public void setTitle(String title) {
	    this.title = title;
	}
	
	public long getUid() {
	    return this.uid;
	}

	public void setUid(long uid) {
	    this.uid = uid;
	}

	public URL getUrl() {
	    return this.url;
	}

	public void setUrl(URL url) {
	    this.url = url;
	}
}