package mest.entity;

import mest.entity.Theme;
import java.util.ArrayList;

import java.net.MalformedURLException;
import java.net.URL;

/**class for managing themes in a private list called themeList*/
public class ThemeManager{

	private static ArrayList<Theme> themeList = new ArrayList<Theme>();

    public static ArrayList<Theme> getThemeList(){
        return themeList;
    }

    /**
    Adds a theme to the list of themes.
    @param theme to be added
    @return boolean describing if addding was successful
    */
	public static boolean addTheme(Theme theme){
        return themeList.add(theme);
    }

    /**
    Removes a theme from the list of themes.
    @param uid of the theme to be removed
    @return boolean describing if removing was successful
    */
    public static boolean removeTheme(long uid){
        for (Theme t : themeList){
            if(t.getUid() == uid){
                return themeList.remove(t);
            }
        }
        return false;
    }
    /**
    set the default theme. For now just return a newly generated theme object here.
    @return default theme
    */
	public static Theme getDefaultTheme(){
        try{
            URL url = new URL("http://www.google.com");
            return new Theme("Default Theme", url);   
        }catch(MalformedURLException e){

            return null;
        }

    }

    /**
    Convenience method. Returns the theme object from the list of themes for the given uid.
    @param uid of the theme to be retrieved
    @return corresponding theme object
    */
    public static Theme getTheme(long uid){
        for (Theme t : themeList){
            if(t.getUid() == uid){
                return t;
            }
        }
        return null;
    }
}