package mest.entity;

import java.util.GregorianCalendar;
import java.net.URL;

/** class describing study of a user */
public class University extends CareerStage{

	private String degree;
	private String focus;

    /**
    This constructor assigns the passed values to the object and creates a new uid
	that is unique among all career stage objects by using numbers starting from 0..n.
    @param universityName of the university
    @param degree achieved during this study
    @param focus description of the main focus areas of the study
    @param startDate beginning of the study
    @param endDate end of the study
    @param website url of the institution's website 
    @param location of the institution
    @param locationURL url pointing to the map location of the institution
    */
	public University(String universityName, String degree, String focus,
        GregorianCalendar startDate, GregorianCalendar endDate, URL website,
        String locationName, URL locationURL){
    	super(universityName, startDate, endDate, website, locationName, locationURL);
	    this.degree = degree;
	    this.focus = focus;
	}

	public String getDegree() {
	    return this.degree;
	}

	public void setDegree(String degree) {
	    this.degree = degree;
	}

	public String getFocus() {
	    return this.focus;
	}

	public void setFocus(String focus) {
	    this.focus = focus;
	}
}