package mest.entity;

import java.net.URL;
import java.util.GregorianCalendar;

/**class describing employment and project work of a user*/
public class Work extends CareerStage{
    
    private String jobTitle;
    private String responsibilities;

    /**
    This constructor assigns the passed values to the object and creates a new uid
    that is unique among all career stage objects by using numbers starting from 0..n.
    @param companyName name of the company the user worked for
    @param jobTitle name of the position
    @param responsibilities description of the main job responsibilities
    @param startDate beginning of the work
    @param endDate end of the work
    @param website url of the institution's website 
    @param location of the institution
    @param locationURL url pointing to the map location of the institution
    */
    public Work(String companyName, String jobTitle, String responsibilities,
            GregorianCalendar startDate, GregorianCalendar endDate, URL website, 
            String locationName, URL locationURL){
        super(companyName, startDate, endDate, website, locationName, locationURL);
        this.jobTitle = jobTitle;
        this.responsibilities = responsibilities;
    }

    public String getJobTitle() {
        return jobTitle;
    }

    public void setJobTitle(String jobTitle) {
        this.jobTitle = jobTitle;
    }

    public String getResponsibilities() {
        return this.responsibilities;
    }

    public void setResponsibilities(String responsibilities) {
        this.responsibilities = responsibilities;
    }
}
